; ##################################################
; #              mIRCSweeper v1.0                  #
; #         By Smay (smayscripts@gmail.com)        #
; #                                                #
; # This script is simply an *almost* exact remake #
; # of the windows version of MineSweeper. The     #
; # Only difference is that using both mouse       #
; # buttons at once won't reveal all possible      #
; # Choices.                                       #
; #                                                #
; #            Notes on game structure             #
; # The PlayerMoves Hash Table works as follows    #
; # Itemname = RowColumn                           #
; # Data: 0 = Not clicked                          #
; #       1 = Clicked                              #
; #       2 = Flagged                              #
; #                                                #
; # The GameBoard Hash Table works as follows      #
; # Itemname = RowColumn                           #
; # Data: 0 = Blank Square                         #
; #       1-8 = Number of mines surrounding square #
; #       Mine = A Mine                            #
; ##################################################

on 1:load: {
  if ($version < 5.91) { echo 4 -a This script requires mIRC 5.91 or better. You can download the latest version at www.mirc.com | halt }
  echo 14 -a Creating game settings...
  writeini -n " $+ $scriptdirmIRCSweeper.ini $+ " Settings LastLevel Beginner
  writeini -n " $+ $scriptdirmIRCSweeper.ini $+ " Beginner Name Anonymous
  writeini -n " $+ $scriptdirmIRCSweeper.ini $+ " Beginner Time 999
  writeini -n " $+ $scriptdirmIRCSweeper.ini $+ " Intermediate Name Anonymous
  writeini -n " $+ $scriptdirmIRCSweeper.ini $+ " Intermediate Time 999
  writeini -n " $+ $scriptdirmIRCSweeper.ini $+ " Expert Name Anonymous
  writeini -n " $+ $scriptdirmIRCSweeper.ini $+ " Expert Time 999
  echo 14 -a Game settings created! Right click and select "Play mIRCSweeper" to play, or type /mIRCSweeper
}

menu status,nicklist,channel,query {
-
Play mIRCSweeper!: { mIRCSweeper }
} 

alias mIRCSweeper {
  if ($1) { var %mIRCSweeper.level $1 }
  else { var %mIRCSweeper.level $readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Settings,LastLevel) }
  if (%mIRCSweeper.level == Intermediate) {
    set %mIRCSweeper.width 288
    set %mIRCSweeper.height 367
    writeini -n " $+ $scriptdirmIRCSweeper.ini $+ " Settings LastLevel Intermediate
  }
  elseif (%mIRCSweeper.level == Expert) {
    set %mIRCSweeper.width 512
    set %mIRCSweeper.height 367
    writeini -n " $+ $scriptdirmIRCSweeper.ini $+ " Settings LastLevel Expert
  }
  else {
    set %mIRCSweeper.width 160
    set %mIRCSweeper.height 239
    writeini -n " $+ $scriptdirmIRCSweeper.ini $+ " Settings LastLevel Beginner
  }
  window -Cdpk0 +tl @mIRCSweeper -1 -1 %mIRCSweeper.width %mIRCSweeper.height
  titlebar @mIRCSweeper v1.0 - Smay
  drawrect -rf @mIRCSweeper $rgb(0,0,0) 1 0 0 %mIRCSweeper.width %mIRCSweeper.height
  if (%mIRCSweeper.width == 160) { 
    drawtext -r @mIRCSweeper $rgb(92,153,255) "MS Sans Serif" 14 $int($calc((%mIRCSweeper.width / 2) - ($width(Generating Board...,MS Sans Serif,14,0,1) / 2))) $int($calc((%mIRCSweeper.height / 2) - ($height(Generating Board...,MS Sans Serif,14) / 2) - 20)) Generating Board...
    drawtext -r @mIRCSweeper $rgb(92,153,255) "MS Sans Serif" 14 $int($calc((%mIRCSweeper.width / 2) - ($width(Please wait,MS Sans Serif,14,0,1) / 2))) $int($calc((%mIRCSweeper.height / 2) - ($height(Please wait,MS Sans Serif,14) / 2))) Please wait
  }
  else { drawtext -r @mIRCSweeper $rgb(92,153,255) "MS Sans Serif" 14 $int($calc((%mIRCSweeper.width / 2) - ($width(Generating Board...Please wait,MS Sans Serif,14,0,1) / 2))) $int($calc((%mIRCSweeper.height / 2) - ($height(Generating Board...Please wait,MS Sans Serif,14) / 2))) Generating Board...Please wait }
  
  drawrect -nfr @mIRCSweeper $rgb(face) 1 0 0 %mIRCSweeper.width %mIRCSweeper.height
  drawline -nr @mIRCSweeper $rgb(hilight) 3 2 $calc(%mIRCSweeper.height - 24) 2 23 $calc(%mIRCSweeper.width - 9) 23
  drawline -nr @mIRCSweeper $rgb(shadow) 3 $calc(%mIRCSweeper.width - 9) 23 $calc(%mIRCSweeper.width - 9) $calc(%mIRCSweeper.height - 24) 2 $calc(%mIRCSweeper.height - 24)
  drawline -nr @mIRCSweeper $rgb(hilight) 1 $calc(%mIRCSweeper.width - 13) 22 $calc(%mIRCSweeper.width - 8) 22
  drawline -nr @mIRCSweeper $rgb(hilight) 1 $calc(%mIRCSweeper.width - 13) 23 $calc(%mIRCSweeper.width - 9) 23
  drawline -nr @mIRCSweeper $rgb(hilight) 1 $calc(%mIRCSweeper.width - 13) 24 $calc(%mIRCSweeper.width - 10) 24
  drawline -nr @mIRCSweeper $rgb(hilight) 1 1 $calc(%mIRCSweeper.height - 25) 4 $calc(%mIRCSweeper.height - 25)
  drawline -nr @mIRCSweeper $rgb(hilight) 1 1 $calc(%mIRCSweeper.height - 24) 3 $calc(%mIRCSweeper.height - 24)
  drawline -nr @mIRCSweeper $rgb(hilight) 1 1 $calc(%mIRCSweeper.height - 23) 2 $calc(%mIRCSweeper.height - 23)
  
  drawtext -pbnr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $int($calc((40 / 2) - ($width(Game,MS Sans Serif,12,0,1) / 2))) $int($calc(1 + (18 / 2) - ($height(Game,MS Sans Serif,12) / 2))) Game
  drawtext -pbnr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $int($calc((40 / 2) - ($width(Help,MS Sans Serif,12,0,1) / 2) + 37)) $int($calc(1 + (18 / 2) - ($height(Help,MS Sans Serif,12) / 2))) Help
  
  mIRCSweeper.DrawBox @mIRCSweeper 2 11 32 $calc(%mIRCSweeper.width - 28) 35
  mIRCSweeper.DrawBox @mIRCSweeper 1 17 37 40 24
  mIRCSweeper.DrawBox @mIRCSweeper 1 $calc(%mIRCSweeper.width - 64) 37 40 24
  
  drawrect -nrf @mIRCSweeper $rgb(0,0,0) 1 $calc((%mIRCSweeper.width - 6) / 2 - 13) 37 26 25
  mIRCSweeper.DrawButton @mIRCSweeper $calc((%mIRCSweeper.width - 6) / 2 - 12) 37 24 24
  mIRCSweeper.DrawSmiley.1 @mIRCSweeper $calc((%mIRCSweeper.width - 6) / 2 - 9) 40 18 18
  
  mIRCSweeper.DrawBox @mIRCSweeper 3 11 75 $calc(%mIRCSweeper.width - 29) $calc(%mIRCSweeper.height - 109)
  
  if ($hget(GameBoard) != $null) { hfree GameBoard }
  if ($hget(PlayerMoves) != $null) { hfree PlayerMoves }
  hmake GameBoard 50 | hmake PlayerMoves 50
  
  set %mIRCSweeper.GameMenuOpen $false
  set %mIRCSweeper.HelpMenuOpen $false
  set %mIRCSweeper.allowgameplay $false
  
  mIRCSweeper.2 %mIRCSweeper.level
}

alias -l mIRCSweeper.2 {  
  var %mIRCSweeper.xcoord 13
  var %mIRCSweeper.ycoord 76
  var %mIRCSweeper.rowcounter 1
  var %mIRCSweeper.colcounter 1
  if ($1 == Intermediate) { var %mIRCSweeper.totalcols 16 | var %mIRCSweeper.totalrows 16 | set %mIRCSweeper.minesleft 40 }
  elseif ($1 == Expert) { var %mIRCSweeper.totalcols 30 | var %mIRCSweeper.totalrows 16 | set %mIRCSweeper.minesleft 99 }
  else { var %mIRCSweeper.totalcols 8 | var %mIRCSweeper.totalrows 8 | set %mIRCSweeper.minesleft 10 }
  while (%mIRCSweeper.rowcounter <= %mIRCSweeper.totalrows) {
    while (%mIRCSweeper.colcounter <= %mIRCSweeper.totalcols) {
      mIRCSweeper.DrawSquare @mIRCSweeper %mIRCSweeper.xcoord %mIRCSweeper.ycoord 15 16
      inc %mIRCSweeper.xcoord 16
      inc %mIRCSweeper.colcounter
    }
    inc %mIRCSweeper.ycoord 16
    var %mIRCSweeper.xcoord 13
    var %mIRCSweeper.colcounter 1
    inc %mIRCSweeper.rowcounter
  }
  
  mIRCSweeper.Numbers 18 38 %mIRCSweeper.minesleft
  mIRCSweeper.Numbers $calc(%mIRCSweeper.width - 63) 38 000
  
  mIRCSweeper.PreFillHashTables %mIRCSweeper.totalrows %mIRCSweeper.totalcols
  mIRCSweeper.GenerateBoard %mIRCSweeper.minesleft %mIRCSweeper.totalrows %mIRCSweeper.totalcols
  
  set %mIRCSweeper.allowgameplay $true
}

alias -l mIRCSweeper.PreFillHashTables {
  var %mIRCSweeper.rowcounter 1
  var %mIRCSweeper.colcounter 1
  while (%mIRCSweeper.rowcounter <= $1) {
    while (%mIRCSweeper.colcounter <= $2) {
      hadd GameBoard %mIRCSweeper.rowcounter $+ $chr(44) $+ %mIRCSweeper.colcounter 0
      hadd PlayerMoves %mIRCSweeper.rowcounter $+ $chr(44) $+ %mIRCSweeper.colcounter 0
      inc %mIRCSweeper.colcounter
    }
    var %mIRCSweeper.colcounter 1
    inc %mIRCSweeper.rowcounter
  }
}

alias -l mIRCSweeper.GenerateBoard {
  var %mIRCSweeper.minerownum $rand(1,$2)
  var %mIRCSweeper.minecolnum $rand(1,$3)
  if ($hget(GameBoard, [ %mIRCSweeper.minerownum ] $+ $chr(44) $+ [ %mIRCSweeper.minecolnum ] ) != Mine) {
    hadd GameBoard %mIRCSweeper.minerownum $+ $chr(44) $+ %mIRCSweeper.minecolnum Mine
    var %mIRCSweeper.counter 1
    while (%mIRCSweeper.counter <= 3) {
      if (%mIRCSweeper.counter == 1) {
        if ($hget(GameBoard,$calc(%mIRCSweeper.minerownum - 1) $+ $chr(44) $+ $calc(%mIRCSweeper.minecolnum - 1)) isnum) { hadd GameBoard $calc(%mIRCSweeper.minerownum - 1) $+ $chr(44) $+ $calc(%mIRCSweeper.minecolnum - 1) $calc($hget(GameBoard,$calc(%mIRCSweeper.minerownum - 1) $+ $chr(44) $+ $calc(%mIRCSweeper.minecolnum - 1)) + 1)  }
        if ($hget(GameBoard, [ %mIRCSweeper.minerownum ] $+ $chr(44) $+ $calc(%mIRCSweeper.minecolnum - 1)) isnum) { hadd GameBoard [ %mIRCSweeper.minerownum ] $+ $chr(44) $+ $calc(%mIRCSweeper.minecolnum - 1) $calc($hget(GameBoard, [ %mIRCSweeper.minerownum ] $+ $chr(44) $+ $calc(%mIRCSweeper.minecolnum - 1)) + 1) }
        if ($hget(GameBoard,$calc(%mIRCSweeper.minerownum + 1) $+ $chr(44) $+ $calc(%mIRCSweeper.minecolnum - 1)) isnum) { hadd GameBoard $calc(%mIRCSweeper.minerownum + 1) $+ $chr(44) $+ $calc(%mIRCSweeper.minecolnum - 1) $calc($hget(GameBoard,$calc(%mIRCSweeper.minerownum + 1) $+ $chr(44) $+ $calc(%mIRCSweeper.minecolnum - 1)) + 1) }
      }
      elseif (%mIRCSweeper.counter == 2) {
        if ($hget(GameBoard,$calc(%mIRCSweeper.minerownum - 1) $+ $chr(44) $+ [ %mIRCSweeper.minecolnum ] ) isnum) { hadd GameBoard $calc(%mIRCSweeper.minerownum - 1) $+ $chr(44) $+ [ %mIRCSweeper.minecolnum ] $calc($hget(GameBoard,$calc(%mIRCSweeper.minerownum - 1) $+ $chr(44) $+ [ %mIRCSweeper.minecolnum ] ) + 1) }
        if ($hget(GameBoard,$calc(%mIRCSweeper.minerownum + 1) $+ $chr(44) $+ [ %mIRCSweeper.minecolnum ] ) isnum) { hadd GameBoard $calc(%mIRCSweeper.minerownum + 1) $+ $chr(44) $+ [ %mIRCSweeper.minecolnum ] $calc($hget(GameBoard,$calc(%mIRCSweeper.minerownum + 1) $+ $chr(44) $+ [ %mIRCSweeper.minecolnum ] ) + 1) }
      }      
      elseif (%mIRCSweeper.counter == 3) {
        if ($hget(GameBoard,$calc(%mIRCSweeper.minerownum - 1) $+ $chr(44) $+ $calc(%mIRCSweeper.minecolnum + 1)) isnum) { hadd GameBoard $calc(%mIRCSweeper.minerownum - 1) $+ $chr(44) $+ $calc(%mIRCSweeper.minecolnum + 1) $calc($hget(GameBoard,$calc(%mIRCSweeper.minerownum - 1) $+ $chr(44) $+ $calc(%mIRCSweeper.minecolnum + 1)) + 1) }
        if ($hget(GameBoard, [ %mIRCSweeper.minerownum ] $+ $chr(44) $+ $calc(%mIRCSweeper.minecolnum + 1)) isnum) { hadd GameBoard [ %mIRCSweeper.minerownum ] $+ $chr(44) $+ $calc(%mIRCSweeper.minecolnum + 1) $calc($hget(GameBoard, [ %mIRCSweeper.minerownum ] $+ $chr(44) $+ $calc(%mIRCSweeper.minecolnum + 1)) + 1) }
        if ($hget(GameBoard,$calc(%mIRCSweeper.minerownum + 1) $+ $chr(44) $+ $calc(%mIRCSweeper.minecolnum + 1)) isnum) { hadd GameBoard $calc(%mIRCSweeper.minerownum + 1) $+ $chr(44) $+ $calc(%mIRCSweeper.minecolnum + 1) $calc($hget(GameBoard,$calc(%mIRCSweeper.minerownum + 1) $+ $chr(44) $+ $calc(%mIRCSweeper.minecolnum + 1)) + 1) }
      }
      inc %mIRCSweeper.counter
    }  
    if ($1 > 1) { .timermIRCSweeper.GenerateBoard -m 1 10 mIRCSweeper.GenerateBoard $calc($1 - 1) $2 $3 }
    else { drawdot @mIRCSweeper }
  }
  else { .timermIRCSweeper.GenerateBoard -m 1 10 mIRCSweeper.GenerateBoard $1 $2 $3 }
}

alias -l mIRCSweeper.GameTimer {
  mIRCSweeper.Numbers $calc(%mIRCSweeper.width - 63) 38 $1
  drawdot @mIRCSweeper
  .timerUpdateGameTimer 1 1 mIRCSweeper.GameTimer $calc($1 + 1)
}

alias -l mIRCSweeper.DrawButton {
  drawrect -nrf $1 $rgb(face) 1 $2 $calc($3 + 1) $4 $calc($5 - 1)
  drawrect -nr $1 $rgb(shadow) 1 $2 $calc($3 + 1) $4 $calc($5 - 1)
  drawline -nr $1 $rgb(hilight) 1 $2 $calc($3 + $5 - 1) $2 $calc($3 + 1) $calc($2 + $4 - 1) $calc($3 + 1)
  if ($6) { drawtext -pbnr $1 $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $int($calc(($4 / 2) - ($width($6-,MS Sans Serif,12,0,1) / 2) + $2)) $int($calc($3 + ($5 / 2) - ($height($6-,MS Sans Serif,12) / 2))) $6- }
}

alias -l mIRCSweeper.DrawButtonDown {
  drawrect -nrf $1 $rgb(face) 1 $2 $calc($3 + 1) $4 $calc($5 - 1)
  drawrect -nr $1 $rgb(hilight) 1 $2 $calc($3 + 1) $4 $calc($5 - 1)
  drawline -nr $1 $rgb(shadow) 1 $2 $calc($3 + $5 - 1) $2 $calc($3 + 1) $calc($2 + $4 - 1) $calc($3 + 1)
}

alias -l mIRCSweeper.DrawSquare {
  drawrect -nrf $1 $rgb(0,0,0) 1 $2 $calc($3 + 1) $calc($4 + 1) $5 
  drawrect -nrf $1 $rgb(face) 1 $2 $calc($3 + 1) $4 $calc($5 - 1)
  drawrect -nr $1 $rgb(shadow) 1 $2 $calc($3 + 1) $4 $calc($5 - 1)
  drawline -nr $1 $rgb(hilight) 1 $2 $calc($3 + $5 - 1) $2 $calc($3 + 1) $calc($2 + $4 - 1) $calc($3 + 1)
}

alias -l mIRCSweeper.DrawSquareDown {
  drawrect -nrf $1 $rgb(0,0,0) 1 $2 $calc($3 + 1) $calc($4 + 1) $5
  drawrect -nrf $1 $rgb(face) 1 $2 $calc($3 + 1) $4 $calc($5 - 1)
  var %mIRCSweeper.counter 1
  var %mIRCSweeper.oddcount 1
  var %mIRCSweeper.evencount 0
  while (%mIRCSweeper.counter <= 8) {
    drawdot -nr $1 $rgb(face) 1 $calc($2 + $4) $calc($3 + %mIRCSweeper.oddcount)
    drawdot -nr $1 $rgb(face) 1 $calc($2 + %mIRCSweeper.evencount) $calc($3 + $5)
    inc %mIRCSweeper.oddcount 2
    inc %mIRCSweeper.evencount 2
    inc %mIRCSweeper.counter
  }
  if ($6 isnum) {
    if ($6 == 0) { mIRCSweeper.RevealAdjacentSquares $calc((($3 - 76) / 16) + 1) $calc((($2 - 13) / 16) + 1) }
    elseif ($6 == 1) { drawtext -nr $1 $rgb(0,0,255) "Fixedsys" 14 $int($calc(($2 + 8) - ($width($6,Fixedsys,14,0,0) / 2))) $int($calc(($3 + 9) - ($height($6,Fixedsys,14) / 2))) $6 }
    elseif ($6 == 2) { drawtext -nr $1 $rgb(0,128,0) "Fixedsys" 14 $int($calc(($2 + 8) - ($width($6,Fixedsys,14,0,0) / 2))) $int($calc(($3 + 9) - ($height($6,Fixedsys,14) / 2))) $6 }
    elseif ($6 == 3) { drawtext -nr $1 $rgb(255,0,0) "Fixedsys" 14 $int($calc(($2 + 8) - ($width($6,Fixedsys,14,0,0) / 2))) $int($calc(($3 + 9) - ($height($6,Fixedsys,14) / 2))) $6 }
    elseif ($6 == 4) { drawtext -nr $1 $rgb(0,0,128) "Fixedsys" 14 $int($calc(($2 + 8) - ($width($6,Fixedsys,14,0,0) / 2))) $int($calc(($3 + 9) - ($height($6,Fixedsys,14) / 2))) $6 }
    elseif ($6 == 5) { drawtext -nr $1 $rgb(128,0,0) "Fixedsys" 14 $int($calc(($2 + 8) - ($width($6,Fixedsys,14,0,0) / 2))) $int($calc(($3 + 9) - ($height($6,Fixedsys,14) / 2))) $6 }
    elseif ($6 == 6) { drawtext -nr $1 $rgb(0,128,128) "Fixedsys" 14 $int($calc(($2 + 8) - ($width($6,Fixedsys,14,0,0) / 2))) $int($calc(($3 + 9) - ($height($6,Fixedsys,14) / 2))) $6 }
    elseif ($6 == 7) { drawtext -nr $1 $rgb(128,0,128) "Fixedsys" 14 $int($calc(($2 + 8) - ($width($6,Fixedsys,14,0,0) / 2))) $int($calc(($3 + 9) - ($height($6,Fixedsys,14) / 2))) $6 }
    else { drawtext -nr $1 $rgb(0,0,0) "Fixedsys" 14 $int($calc(($2 + 8) - ($width($6,Fixedsys,14,0,0) / 2))) $int($calc(($3 + 9) - ($height($6,Fixedsys,14) / 2))) $6 }
  }
  elseif ($6 == Mine) {
    .timerUpdateGameTimer off
    set %mIRCSweeper.allowgameplay $false Lose
    unset %mIRCSweeper.xcoord %mIRCSweeper.ycoord %mIRCSweeper.SquareClicked
    mIRCSweeper.RevealAllMines
    drawrect -nrf @mIRCSweeper $rgb(255,0,0) 1 $2 $calc($3 + 1) 15 15
    mIRCSweeper.DrawMine $1 $2 $calc($3 + 1) 15 16
    mIRCSweeper.DrawSmiley.3 @mIRCSweeper $calc((%mIRCSweeper.width - 6) / 2 - 9) 40 18 18
    drawdot @mIRCSweeper
  }
  if ($calc($hfind(PlayerMoves,0,0).data + $hfind(PlayerMoves,2,0).data) == $hfind(GameBoard,Mine,0).data) {
    var %mIRCSweeper.TimeTaken $calc($gettok($timer(UpdateGameTimer).com,2,32) - 1)
    .timerUpdateGameTimer off
    set %mIRCSweeper.allowgameplay $false Win
    unset %mIRCSweeper.xcoord %mIRCSweeper.ycoord %mIRCSweeper.SquareClicked
    mIRCSweeper.Numbers 18 38 0
    mIRCSweeper.DrawSmiley.4 @mIRCSweeper $calc((%mIRCSweeper.width - 6) / 2 - 9) 40 18 18
    if (%mIRCSweeper.minesleft > 0) {
      if ($hget(GameBoard,0).item == 64) { var %mIRCSweeper.totalrows 8 | var %mIRCSweeper.totalcols 8 }
      elseif ($hget(GameBoard,0).item == 256) { var %mIRCSweeper.totalrows 16 | var %mIRCSweeper.totalcols 16 }
      else { var %mIRCSweeper.totalrows 16 | var %mIRCSweeper.totalcols 30 }
      var %mIRCSweeper.rowcounter 1
      var %mIRCSweeper.colcounter 1
      while (%mIRCSweeper.rowcounter <= %mIRCSweeper.totalrows) {
        while (%mIRCSweeper.colcounter <= %mIRCSweeper.totalcols) {
          if ($hget(PlayerMoves, [ %mIRCSweeper.rowcounter ] $+ $chr(44) $+ [ %mIRCSweeper.colcounter ] ) == 0) {
            mIRCSweeper.DrawFlag @mIRCSweeper $calc(((%mIRCSweeper.colcounter - 1) * 16) + 13) $calc(((%mIRCSweeper.rowcounter - 1) * 16) + 76) 15 16
            hadd PlayerMoves [ %mIRCSweeper.rowcounter ] $+ $chr(44) $+ [ %mIRCSweeper.colcounter ] 2
            dec %mIRCSweeper.minesleft
          }
          inc %mIRCSweeper.colcounter
        }
        var %mIRCSweeper.colcounter 1
        inc %mIRCSweeper.rowcounter
      }
    }
    if (%mIRCSweeper.TimeTaken < $readini(" $+ $scriptdirmIRCSweeper.ini $+ ",$readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Settings,LastLevel),Time)) {
      var %mIRCSweeper.UserName $input(You have the fastest time for $readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Settings,LastLevel) level. Please type your name:,5,Congratulations,$readini(" $+ $scriptdirmIRCSweeper.ini $+ ",$readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Settings,LastLevel),Name))
      writeini -n " $+ $scriptdirmIRCSweeper.ini $+ " $readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Settings,LastLevel) Name %mIRCSweeper.UserName
      writeini -n " $+ $scriptdirmIRCSweeper.ini $+ " $readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Settings,LastLevel) Time %mIRCSweeper.TimeTaken
      dialog -ma mIRCSweeper.HighScores mIRCSweeper.HighScores
    }
  }
}

alias -l mIRCSweeper.RevealAdjacentSquares {
  if ($hget(PlayerMoves,$calc($1 - 1) $+ $chr(44) $+ $calc($2 - 1)) == 0) {
    hadd PlayerMoves $calc($1 - 1) $+ $chr(44) $+ $calc($2 - 1) 1
    mIRCSweeper.DrawSquareDown @mIRCSweeper $calc(((($2 - 1) - 1) * 16) + 13) $calc(((($1 - 1) - 1) * 16) + 76) 15 16 $hget(GameBoard,$calc($1 - 1) $+ $chr(44) $+ $calc($2 - 1))
  }
  if ($hget(PlayerMoves,$calc($1 - 1) $+ $chr(44) $+ $2) == 0) { 
    hadd PlayerMoves $calc($1 - 1) $+ $chr(44) $+ $2 1
    mIRCSweeper.DrawSquareDown @mIRCSweeper $calc((($2 - 1) * 16) + 13) $calc(((($1 - 1) - 1) * 16) + 76) 15 16 $hget(GameBoard,$calc($1 - 1) $+ $chr(44) $+ $2)
  }
  if ($hget(PlayerMoves,$calc($1 - 1) $+ $chr(44) $+ $calc($2 + 1)) == 0) { 
    hadd PlayerMoves $calc($1 - 1) $+ $chr(44) $+ $calc($2 + 1) 1
    mIRCSweeper.DrawSquareDown @mIRCSweeper $calc(((($2 + 1) - 1) * 16) + 13) $calc(((($1 - 1) - 1) * 16) + 76) 15 16 $hget(GameBoard,$calc($1 - 1) $+ $chr(44) $+ $calc($2 + 1))
  }
  if ($hget(PlayerMoves,$1 $+ $chr(44) $+ $calc($2 - 1)) == 0) { 
    hadd PlayerMoves $1 $+ $chr(44) $+ $calc($2 - 1) 1
    mIRCSweeper.DrawSquareDown @mIRCSweeper $calc(((($2 - 1) - 1) * 16) + 13) $calc((($1 - 1) * 16) + 76) 15 16 $hget(GameBoard,$1 $+ $chr(44) $+ $calc($2 - 1))
  }
  if ($hget(PlayerMoves,$1 $+ $chr(44) $+ $calc($2 + 1)) == 0) { 
    hadd PlayerMoves $1 $+ $chr(44) $+ $calc($2 + 1) 1
    mIRCSweeper.DrawSquareDown @mIRCSweeper $calc(((($2 + 1) - 1) * 16) + 13) $calc((($1 - 1) * 16) + 76) 15 16 $hget(GameBoard,$1 $+ $chr(44) $+ $calc($2 + 1))
  }
  if ($hget(PlayerMoves,$calc($1 + 1) $+ $chr(44) $+ $calc($2 - 1)) == 0) { 
    hadd PlayerMoves $calc($1 + 1) $+ $chr(44) $+ $calc($2 - 1) 1
    mIRCSweeper.DrawSquareDown @mIRCSweeper $calc(((($2 - 1) - 1) * 16) + 13) $calc(((($1 + 1) - 1) * 16) + 76) 15 16 $hget(GameBoard,$calc($1 + 1) $+ $chr(44) $+ $calc($2 - 1))
  }
  if ($hget(PlayerMoves,$calc($1 + 1) $+ $chr(44) $+ $2) == 0) { 
    hadd PlayerMoves $calc($1 + 1) $+ $chr(44) $+ $2 1
    mIRCSweeper.DrawSquareDown @mIRCSweeper $calc((($2 - 1) * 16) + 13) $calc(((($1 + 1) - 1) * 16) + 76) 15 16 $hget(GameBoard,$calc($1 + 1) $+ $chr(44) $+ $2)
  }
  if ($hget(PlayerMoves,$calc($1 + 1) $+ $chr(44) $+ $calc($2 + 1)) == 0) { 
    hadd PlayerMoves $calc($1 + 1) $+ $chr(44) $+ $calc($2 + 1) 1
    mIRCSweeper.DrawSquareDown @mIRCSweeper $calc(((($2 + 1) - 1) * 16) + 13) $calc(((($1 + 1) - 1) * 16) + 76) 15 16 $hget(GameBoard,$calc($1 + 1) $+ $chr(44) $+ $calc($2 + 1))
  }
}

alias -l mIRCSweeper.RevealAllMines {
  if ($hget(GameBoard,0).item == 64) { var %mIRCSweeper.totalrows 8 | var %mIRCSweeper.totalcols 8 }
  elseif ($hget(GameBoard,0).item == 256) { var %mIRCSweeper.totalrows 16 | var %mIRCSweeper.totalcols 16 }
  else { var %mIRCSweeper.totalrows 16 | var %mIRCSweeper.totalcols 30 }
  var %mIRCSweeper.rowcounter 1
  var %mIRCSweeper.colcounter 1
  while (%mIRCSweeper.rowcounter <= %mIRCSweeper.totalrows) {
    while (%mIRCSweeper.colcounter <= %mIRCSweeper.totalcols) {
      if (($hget(GameBoard, [ %mIRCSweeper.rowcounter ] $+ $chr(44) $+ [ %mIRCSweeper.colcounter ] ) == Mine) && ($hget(PlayerMoves, [ %mIRCSweeper.rowcounter ] $+ $chr(44) $+ [ %mIRCSweeper.colcounter ] ) == 0)) { 
        mIRCSweeper.DrawSquareDown @mIRCSweeper $calc(((%mIRCSweeper.colcounter - 1) * 16) + 13) $calc(((%mIRCSweeper.rowcounter - 1) * 16) + 76) 15 16 
        mIRCSweeper.DrawMine @mIRCSweeper $calc(((%mIRCSweeper.colcounter - 1) * 16) + 13) $calc(((%mIRCSweeper.rowcounter - 1) * 16) + 76) 15 16
      }
      if (($hget(GameBoard, [ %mIRCSweeper.rowcounter ] $+ $chr(44) $+ [ %mIRCSweeper.colcounter ] ) isnum) && ($hget(PlayerMoves, [ %mIRCSweeper.rowcounter ] $+ $chr(44) $+ [ %mIRCSweeper.colcounter ] ) == 2)) {
        mIRCSweeper.DrawSquareDown @mIRCSweeper $calc(((%mIRCSweeper.colcounter - 1) * 16) + 13) $calc(((%mIRCSweeper.rowcounter - 1) * 16) + 76) 15 16 
        mIRCSweeper.BadFlag @mIRCSweeper $calc(((%mIRCSweeper.colcounter - 1) * 16) + 13) $calc(((%mIRCSweeper.rowcounter - 1) * 16) + 76) 15 16
      }
      inc %mIRCSweeper.colcounter
    }
    var %mIRCSweeper.colcounter 1
    inc %mIRCSweeper.rowcounter
  }
}

alias -l mIRCSweeper.ReDrawBoard {
  drawrect -nfr @mIRCSweeper $rgb(face) 1 0 0 130 160
  drawline -nr @mIRCSweeper $rgb(hilight) 3 2 160 2 23 130 23  
    
  drawtext -pbnr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $int($calc((40 / 2) - ($width(Game,MS Sans Serif,12,0,1) / 2))) $int($calc(1 + (18 / 2) - ($height(Game,MS Sans Serif,12) / 2))) Game
  drawtext -pbnr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $int($calc((40 / 2) - ($width(Help,MS Sans Serif,12,0,1) / 2) + 37)) $int($calc(1 + (18 / 2) - ($height(Help,MS Sans Serif,12) / 2))) Help
  
  mIRCSweeper.DrawBox @mIRCSweeper 2 11 32 $calc(%mIRCSweeper.width - 28) 35
  mIRCSweeper.DrawBox @mIRCSweeper 1 17 37 40 24
  mIRCSweeper.DrawBox @mIRCSweeper 1 $calc(%mIRCSweeper.width - 64) 37 40 24
  
  if ($readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Settings,LastLevel) == Beginner) {
    mIRCSweeper.DrawBox @mIRCSweeper 1 $calc(%mIRCSweeper.width - 64) 37 40 24
    drawrect -nrf @mIRCSweeper $rgb(0,0,0) 1 $calc((%mIRCSweeper.width - 6) / 2 - 13) 37 26 25
    mIRCSweeper.DrawButton @mIRCSweeper $calc((%mIRCSweeper.width - 6) / 2 - 12) 37 24 24
    mIRCSweeper.DrawSmiley.1 @mIRCSweeper $calc((%mIRCSweeper.width - 6) / 2 - 9) 40 18 18    
  }
    
  mIRCSweeper.DrawBox @mIRCSweeper 3 11 75 $calc(%mIRCSweeper.width - 29) $calc(%mIRCSweeper.height - 109)
  drawline -nr @mIRCSweeper $rgb(0,0,0) 1 12 $calc(%mIRCSweeper.height - 35) $calc(%mIRCSweeper.width - 19) $calc(%mIRCSweeper.height - 35)
    
  set %mIRCSweeper.GameMenuOpen $false
  set %mIRCSweeper.HelpMenuOpen $false
  
  var %mIRCSweeper.xcoord 13 | var %mIRCSweeper.ycoord 76 | var %mIRCSweeper.rowcounter 1 | var %mIRCSweeper.colcounter 1
  while (%mIRCSweeper.rowcounter <= 6) {
    while (%mIRCSweeper.colcounter <= 8) {
      if ($hget(PlayerMoves, [ %mIRCSweeper.rowcounter ] $+ $chr(44) $+ [ %mIRCSweeper.colcounter ] ) == 0) { mIRCSweeper.DrawSquare @mIRCSweeper %mIRCSweeper.xcoord %mIRCSweeper.ycoord 15 16 }
      elseif ($hget(PlayerMoves, [ %mIRCSweeper.rowcounter ] $+ $chr(44) $+ [ %mIRCSweeper.colcounter ] ) == 1) { mIRCSweeper.DrawSquareDown @mIRCSweeper %mIRCSweeper.xcoord %mIRCSweeper.ycoord 15 16 $hget(GameBoard, [ %mIRCSweeper.rowcounter ] $+ $chr(44) $+ [ %mIRCSweeper.colcounter ] ) }
      elseif ($hget(PlayerMoves, [ %mIRCSweeper.rowcounter ] $+ $chr(44) $+ [ %mIRCSweeper.colcounter ] ) == 2) { 
        mIRCSweeper.DrawSquare @mIRCSweeper %mIRCSweeper.xcoord %mIRCSweeper.ycoord 15 16
        mIRCSweeper.DrawFlag @mIRCSweeper %mIRCSweeper.xcoord %mIRCSweeper.ycoord 15 16
      }
      inc %mIRCSweeper.xcoord 16
      inc %mIRCSweeper.colcounter
    }
    inc %mIRCSweeper.ycoord 16
    var %mIRCSweeper.xcoord 13
    var %mIRCSweeper.colcounter 1
    inc %mIRCSweeper.rowcounter
  }
  
  mIRCSweeper.Numbers 18 38 %mIRCSweeper.minesleft
  if ($timer(UpdateGameTimer).secs == $null) { mIRCSweeper.Numbers $calc(%mIRCSweeper.width - 63) 38 000 }
  else { mIRCSweeper.Numbers $calc($gettok($timer(UpdateGameTimer).com,2,32) - 1) }
}

alias -l mIRCSweeper.DrawSmiley.1 {
  drawrect -ner $1 $rgb(0,0,0) 1 $2 $calc($3 + 1) $4 $calc($5 - 1)
  drawrect -nerf $1 $rgb(255,255,0) 1 $calc($2 + 1) $calc($3 + 2) $calc($4 - 2) $calc($5 - 3)
  drawrect -nrf $1 $rgb(0,0,0) 1 $calc($2 + 5) $calc($3 + 6) 2 2
  drawrect -nrf $1 $rgb(0,0,0) 1 $calc($2 + $4 - 7) $calc($3 + 6) 2 2
  drawline -nr $1 $rgb(0,0,0) 1 $calc($2 + 4) $calc($3 + 11) $calc($2 + 6) $calc($3 + 13) $calc($2 + 11) $calc($3 + 13) $calc($2 + 14) $calc($3 + 10)
}

alias -l mIRCSweeper.DrawSmiley.2 {
  drawrect -ner $1 $rgb(0,0,0) 1 $2 $calc($3 + 1) $4 $calc($5 - 1)
  drawrect -nerf $1 $rgb(255,255,0) 1 $calc($2 + 1) $calc($3 + 2) $calc($4 - 2) $calc($5 - 3)
  drawrect -nerf $1 $rgb(0,0,0) 1 $calc($2 + 5 - 1) $calc($3 + 5) 3 3
  drawrect -nerf $1 $rgb(0,0,0) 1 $calc($2 + $4 - 7) $calc($3 + 5) 3 3
  drawrect -nr $1 $rgb(0,0,0) 1 $calc($2 + 5 + 2) $calc($3 + 10) 4 5
  drawdot -nr $1 $rgb(255,255,0) 1 $calc($2 + 5 + 2) $calc($3 + 10)
  drawdot -nr $1 $rgb(255,255,0) 1 $calc($2 + 5 + 2) $calc($3 + 14)
  drawdot -nr $1 $rgb(255,255,0) 1 $calc($2 + 5 + 5) $calc($3 + 10)
  drawdot -nr $1 $rgb(255,255,0) 1 $calc($2 + 5 + 5) $calc($3 + 14)
}

alias -l mIRCSweeper.DrawSmiley.3 {
  drawrect -ner $1 $rgb(0,0,0) 1 $2 $calc($3 + 1) $4 $calc($5 - 1)
  drawrect -nerf $1 $rgb(255,255,0) 1 $calc($2 + 1) $calc($3 + 2) $calc($4 - 2) $calc($5 - 3)
  drawrect -nrf $1 $rgb(0,0,0) 1 $calc($2 + 5 - 1) $calc($3 + 5) 3 3
  drawrect -nrf $1 $rgb(0,0,0) 1 $calc($2 + $4 - 7) $calc($3 + 5) 3 3
  drawline -nr $1 $rgb(0,0,0) 1 $calc($2 + 4) $calc($3 + 13) $calc($2 + 6) $calc($3 + 11) $calc($2 + 11) $calc($3 + 11) $calc($2 + 14) $calc($3 + 14)
  drawdot -nr $1 $rgb(255,255,0) 1 $calc($2 + 5) $calc($3 + 5)
  drawdot -nr $1 $rgb(255,255,0) 1 $calc($2 + 5) $calc($3 + 7)
  drawdot -nr $1 $rgb(255,255,0) 1 $calc($2 + 4) $calc($3 + 6)
  drawdot -nr $1 $rgb(255,255,0) 1 $calc($2 + 6) $calc($3 + 6)
  drawdot -nr $1 $rgb(255,255,0) 1 $calc($2 + $4 - 6) $calc($3 + 5)
  drawdot -nr $1 $rgb(255,255,0) 1 $calc($2 + $4 - 6) $calc($3 + 7)
  drawdot -nr $1 $rgb(255,255,0) 1 $calc($2 + $4 - 7) $calc($3 + 6)
  drawdot -nr $1 $rgb(255,255,0) 1 $calc($2 + $4 - 5) $calc($3 + 6)
}

alias -l mIRCSweeper.DrawSmiley.4 {
  drawrect -ner $1 $rgb(0,0,0) 1 $2 $calc($3 + 1) $4 $calc($5 - 1)
  drawrect -nerf $1 $rgb(255,255,0) 1 $calc($2 + 1) $calc($3 + 2) $calc($4 - 2) $calc($5 - 3)
  drawrect -nerf $1 $rgb(0,0,0) 1 $calc($2 + 4) $calc($3 + 5) 4 5
  drawrect -nerf $1 $rgb(0,0,0) 1 $calc($2 + $4 - 8) $calc($3 + 5) 4 5
  drawline -nr $1 $rgb(255,255,0) 1 $calc($2 + 4) $calc($3 + 5) $calc($2 + $4 - 3) $calc($3 + 5) 
  drawline -nr $1 $rgb(0,0,0) 1 $calc($2 + 1) $calc($3 + 8) $calc($2 + 3) $calc($3 + 6) $calc($2 + $4 - 4) $calc($3 + 6) $calc($2 + $4 - 1) $calc($3 + 9)
  drawline -nr $1 $rgb(0,0,0) 1 $calc($2 + 5) $calc($3 + 12) $calc($2 + 6) $calc($3 + 13) $calc($2 + 11) $calc($3 + 13) $calc($2 + 13) $calc($3 + 11)
}

alias -l mIRCSweeper.DrawMine {
  drawrect -nfr $1 $rgb(0,0,0) 1 $calc($2 + 5) $int($calc($3 + ($5 / 2) - 3)) 5 5
  drawdot -nr $1 $rgb(255,255,255) 1 $calc($2 + 6) $int($calc($3 + ($5 / 2) - 2))
  drawline -nr $1 $rgb(0,0,0) 1 $calc($2 + 3) $int($calc($3 + ($5 / 2) - 1)) $calc($2 + $4 - 3) $int($calc($3 + ($5 / 2) - 1))
  drawline -nr $1 $rgb(0,0,0) 1 $int($calc($2 + ($4 / 2))) $calc($3 + 3) $int($calc($2 + ($4 / 2))) $calc($3 + $5 - 4)
  drawdot -nr $1 $rgb(0,0,0) 1 $calc($2 + 4) $int($calc($3 + ($5 / 2) - 4))
  drawdot -nr $1 $rgb(0,0,0) 1 $calc($2 + 4) $int($calc($3 + ($5 / 2) + 2))
  drawdot -nr $1 $rgb(0,0,0) 1 $calc($2 + $4 - 5) $int($calc($3 + ($5 / 2) - 4))
  drawdot -nr $1 $rgb(0,0,0) 1 $calc($2 + $4 - 5) $int($calc($3 + ($5 / 2) + 2))
}

alias -l mIRCSweeper.DrawFlag {
  drawrect -nfr $1 $rgb(255,0,0) 1 $calc($2 + 4) $calc($3 + 4) 5 4
  drawline -nr $1 $rgb(128,0,0) 1 $calc($2 + 8) $calc($3 + 4) $calc($2 + 9) $calc($3 + 4)
  drawline -nr $1 $rgb(128,0,0) 1 $calc($2 + 7) $calc($3 + 5) $calc($2 + 9) $calc($3 + 5)
  drawline -nr $1 $rgb(128,0,0) 1 $calc($2 + 6) $calc($3 + 6) $calc($2 + 9) $calc($3 + 6)
  drawline -nr $1 $rgb(128,0,0) 1 $calc($2 + 5) $calc($3 + 7) $calc($2 + 9) $calc($3 + 7)
  drawline -nr $1 $rgb(0,0,0) 1 $calc($2 + 8) $calc($3 + 8) $calc($2 + 8) $calc($3 + 12)
  drawline -nr $1 $rgb(0,0,0) 1 $calc($2 + 7) $calc($3 + 12) $calc($2 + 10) $calc($3 + 12)
  drawline -nr $1 $rgb(0,0,0) 1 $calc($2 + 5) $calc($3 + 13) $calc($2 + 12) $calc($3 + 13)
}

alias -l mIRCSweeper.BadFlag {
  drawline -nr $1 $rgb(255,0,0) 1 $calc($2 + 4) $calc($3 + 4) $calc($2 + 8) $calc($3 + 8)
  drawline -nr $1 $rgb(255,0,0) 1 $calc($2 + 3) $calc($3 + 4) $calc($2 + 8) $calc($3 + 9)
  drawline -nr $1 $rgb(255,0,0) 1 $calc($2 + 8) $calc($3 + 7) $calc($2 + 12) $calc($3 + 3)
  drawline -nr $1 $rgb(255,0,0) 1 $calc($2 + 8) $calc($3 + 8) $calc($2 + 13) $calc($3 + 3)
  drawline -nr $1 $rgb(255,0,0) 1 $calc($2 + 4) $calc($3 + 12) $calc($2 + 8) $calc($3 + 8)
  drawline -nr $1 $rgb(255,0,0) 1 $calc($2 + 3) $calc($3 + 12) $calc($2 + 8) $calc($3 + 7)
  drawline -nr $1 $rgb(255,0,0) 1 $calc($2 + 8) $calc($3 + 9) $calc($2 + 12) $calc($3 + 13)
  drawline -nr $1 $rgb(255,0,0) 1 $calc($2 + 8) $calc($3 + 8) $calc($2 + 13) $calc($3 + 13)
  
  drawline -nr $1 $rgb(128,0,0) 1 $calc($2 + 3) $calc($3 + 5) $calc($2 + 7) $calc($3 + 9)
  drawline -nr $1 $rgb(128,0,0) 1 $calc($2 + 9) $calc($3 + 8) $calc($2 + 13) $calc($3 + 4)
  drawline -nr $1 $rgb(128,0,0) 1 $calc($2 + 3) $calc($3 + 13) $calc($2 + 4) $calc($3 + 13) $calc($2 + 8) $calc($3 + 9)
  drawline -nr $1 $rgb(128,0,0) 1 $calc($2 + 8) $calc($3 + 10) $calc($2 + 12) $calc($3 + 14)
  drawdot -nr $1 $rgb(128,0,0) 1 $calc($2 + 12) $calc($3 + 13)
}

; /mIRCSweeper.DrawBox <@Window> <Size> <x> <y> <w> <h> [Text]
alias -l mIRCSweeper.DrawBox {
  drawline -nr $1 $rgb(shadow) $2 $3 $calc($4 + $6) $3 $4 $calc($3 + $5) $4
  drawline -nr $1 $rgb(hilight) $2 $calc($3 + $5) $4 $calc($3 + $5) $calc($4 + $6) $3 $calc($4 + $6)
  
  if ($len($calc($2 / 2)) > 1) {
    var %mIRCSweeper.counter $2
    var %mIRCSweeper.bottom $calc($4 + $6 + $int($calc(($2 / 2))) + 1)
    var %mIRCSweeper.right $calc($3 - $int($calc($2 / 2)))
    while (%mIRCSweeper.counter >= 0) {
      drawline -nr $1 $rgb(shadow) 1 $calc($3 - $int($calc($2 / 2))) %mIRCSweeper.bottom %mIRCSweeper.right %mIRCSweeper.bottom
      inc %mIRCSweeper.right
      dec %mIRCSweeper.bottom
      dec %mIRCSweeper.counter
    }
    
    var %mIRCSweeper.counter $2
    var %mIRCSweeper.top $calc($4 - $int($calc(($2 / 2))))
    var %mIRCSweeper.right $calc($3 + $5 + $int($calc($2 / 2)) + 1)
    while (%mIRCSweeper.counter >= 0) {
      drawline -nr $1 $rgb(shadow) 1 $calc($3 + $5 - $int($calc($2 / 2))) %mIRCSweeper.top %mIRCSweeper.right %mIRCSweeper.top
      dec %mIRCSweeper.right
      inc %mIRCSweeper.top
      dec %mIRCSweeper.counter
    }
  }
  else {
    var %mIRCSweeper.counter $2
    var %mIRCSweeper.bottom $calc($4 + $6 + $int($calc(($2 / 2))))
    var %mIRCSweeper.right $calc($3 - $int($calc($2 / 2)))
    while (%mIRCSweeper.counter >= 0) {
      drawline -nr $1 $rgb(shadow) 1 $calc($3 - $int($calc($2 / 2))) %mIRCSweeper.bottom %mIRCSweeper.right %mIRCSweeper.bottom
      inc %mIRCSweeper.right
      dec %mIRCSweeper.bottom
      dec %mIRCSweeper.counter
    }
    
    var %mIRCSweeper.counter $2
    var %mIRCSweeper.top $calc($4 - $int($calc(($2 / 2))))
    var %mIRCSweeper.right $calc($3 + $5 + $int($calc($2 / 2)))
    while (%mIRCSweeper.counter >= 0) {
      drawline -nr $1 $rgb(shadow) 1 $calc($3 + $5 - $int($calc($2 / 2))) %mIRCSweeper.top %mIRCSweeper.right %mIRCSweeper.top
      dec %mIRCSweeper.right
      inc %mIRCSweeper.top
      dec %mIRCSweeper.counter
    }
  }
  if ($7) { drawtext -pbnr $1 $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $int($calc(($5 / 2) - ($width($7-,MS Sans Serif,12,0,1) / 2) + $3)) $int($calc($4 + ($6 / 2) - ($height($7-,MS Sans Serif,12) / 2))) $7- }
}

alias -l mIRCSweeper.Numbers {
  if ($len($3) == 3) { var %mIRCSweeper.FirstNum $mid($3,1,1) | var %mIRCSweeper.SecondNum $mid($3,2,1) | var %mIRCSweeper.ThirdNum $right($3,1) }
  elseif ($len($3) == 2) { var %mIRCSweeper.FirstNum 0 | var %mIRCSweeper.SecondNum $mid($3,1,1) | var %mIRCSweeper.ThirdNum $right($3,1) }
  elseif ($len($3) == 1) { var %mIRCSweeper.FirstNum 0 | var %mIRCSweeper.SecondNum 0 | var %mIRCSweeper.ThirdNum $right($3,1) }
  else { var %mIRCSweeper.FirstNum 9 | var %mIRCSweeper.SecondNum 9 | var %mIRCSweeper.ThirdNum 9 }
  if ($3 < 0) { var %mIRCSweeper.FirstNum 10 }
  if ((%mIRCSweeper.GameMenuOpen == $false) && (%mIRCSweeper.HelpMenuOpen == $false)) {
    drawpic -cn @mIRCSweeper $1 $2 $calc(%mIRCSweeper.FirstNum * 13 + 13) 0 13 23 " $+ $scriptdirnumbers.jpg $+ "
    drawpic -cn @mIRCSweeper $calc($1 + 13) $2 $calc(%mIRCSweeper.SecondNum * 13 + 13) 0 13 23 " $+ $scriptdirnumbers.jpg $+ "
    drawpic -cn @mIRCSweeper $calc($1 + 26) $2 $calc(%mIRCSweeper.ThirdNum * 13 + 13) 0 13 23 " $+ $scriptdirnumbers.jpg $+ "
  }
}

alias -l mIRCSweeper.BuildGameMenu {
  drawrect -nhrf @mIRCSweeper $rgb(face) 1 $calc($1 + 1) $calc($2 + 1) 124 135
  drawline -nhr @mIRCSweeper $rgb(hilight) 1 $1 $calc($2 + 137) $1 $2 $calc($1 + 126) $2
  drawline -nhr @mIRCSweeper $rgb(shadow) 1 $1 $calc($2 + 136) $calc($1 + 125) $calc($2 + 136) $calc($1 + 125) $2
  drawtext -pbnhr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $calc($1 + 23) $calc($2 + 3) New
  drawtext -nbhr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $calc($1 + 92) $calc($2 + 3) F2
  
  drawline -nhr @mIRCSweeper $rgb(shadow) 1 $calc($1 + 3) $calc($2 + 22) $calc($1 + 122) $calc($2 + 22)
  drawline -nhr @mIRCSweeper $rgb(hilight) 1 $calc($1 + 3) $calc($2 + 23) $calc($1 + 122) $calc($2 + 23)
  
  drawtext -pbnhr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $calc($1 + 23) $calc($2 + 29) Beginner
  drawtext -pbnhr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $calc($1 + 23) $calc($2 + 47) Intermediate
  drawtext -pbnhr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $calc($1 + 23) $calc($2 + 65) Expert
  
  drawline -nhr @mIRCSweeper $rgb(shadow) 1 $calc($1 + 3) $calc($2 + 84) $calc($1 + 122) $calc($2 + 84)
  drawline -nhr @mIRCSweeper $rgb(hilight) 1 $calc($1 + 3) $calc($2 + 85) $calc($1 + 122) $calc($2 + 85)
  
  drawtext -pbnhr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $calc($1 + 23) $calc($2 + 91) Best Times
  
  drawline -nhr @mIRCSweeper $rgb(shadow) 1 $calc($1 + 3) $calc($2 + 110) $calc($1 + 122) $calc($2 + 110)
  drawline -nhr @mIRCSweeper $rgb(hilight) 1 $calc($1 + 3) $calc($2 + 111) $calc($1 + 122) $calc($2 + 111)
  
  drawtext -pbnhr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $calc($1 + 23) $calc($2 + 117) Exit
}

alias -l mIRCSweeper.HighlightMenuItem {    
  if ($inrect(1,$1,1,22,124,18)) {
    mIRCSweeper.BuildGameMenu 1 22
    drawrect -nhrf @mIRCSweeper $rgb(0,0,128) 1 $calc(1 + 2) $calc(22 + 2) 121 17
    drawtext -pbnhr @mIRCSweeper $rgb(255,255,255) $rgb(0,0,128) "MS Sans Serif" 12 $calc(1 + 23) $calc(22 + 3) New
    drawtext -nbhr @mIRCSweeper $rgb(255,255,255) $rgb(0,0,128) "MS Sans Serif" 12 $calc(1 + 92) $calc(22 + 3) F2
    drawdot @mIRCSweeper
  }
  elseif ($inrect(1,$1,1,51,124,18)) {
    mIRCSweeper.BuildGameMenu 1 22
    drawrect -nhrf @mIRCSweeper $rgb(0,0,128) 1 $calc(1 + 2) $calc(22 + 28) 121 17
    drawtext -pbnhr @mIRCSweeper $rgb(255,255,255) $rgb(0,0,128) "MS Sans Serif" 12 $calc(1 + 23) $calc(22 + 29) Beginner
    drawdot @mIRCSweeper
  }
  elseif ($inrect(1,$1,1,69,124,18)) {
    mIRCSweeper.BuildGameMenu 1 22
    drawrect -nhrf @mIRCSweeper $rgb(0,0,128) 1 $calc(1 + 2) $calc(22 + 46) 121 17
    drawtext -pbnhr @mIRCSweeper $rgb(255,255,255) $rgb(0,0,128) "MS Sans Serif" 12 $calc(1 + 23) $calc(22 + 47) Intermediate
    drawdot @mIRCSweeper
  }
  elseif ($inrect(1,$1,1,87,124,18)) {
    mIRCSweeper.BuildGameMenu 1 22
    drawrect -nhrf @mIRCSweeper $rgb(0,0,128) 1 $calc(1 + 2) $calc(22 + 64) 121 17
    drawtext -pbnhr @mIRCSweeper $rgb(255,255,255) $rgb(0,0,128) "MS Sans Serif" 12 $calc(1 + 23) $calc(22 + 65) Expert
    drawdot @mIRCSweeper
  }
  elseif ($inrect(1,$1,1,113,124,18)) {
    mIRCSweeper.BuildGameMenu 1 22
    drawrect -nhrf @mIRCSweeper $rgb(0,0,128) 1 $calc(1 + 2) $calc(22 + 90) 121 17
    drawtext -pbnhr @mIRCSweeper $rgb(255,255,255) $rgb(0,0,128) "MS Sans Serif" 12 $calc(1 + 23) $calc(22 + 91) Best Times
    drawdot @mIRCSweeper
  }
  elseif ($inrect(1,$1,1,139,124,18)) {
    mIRCSweeper.BuildGameMenu 1 22
    drawrect -nhrf @mIRCSweeper $rgb(0,0,128) 1 $calc(1 + 2) $calc(22 + 116) 121 17
    drawtext -pbnhr @mIRCSweeper $rgb(255,255,255) $rgb(0,0,128) "MS Sans Serif" 12 $calc(1 + 23) $calc(22 + 117) Exit
    drawdot @mIRCSweeper
  }
  else { mIRCSweeper.BuildGameMenu 1 22 }
}

alias -l mIRCSweeper.BuildHelpMenu {
  drawrect -nhrf @mIRCSweeper $rgb(face) 1 $calc($1 + 1) $calc($2 + 1) 75 45
  drawline -nhr @mIRCSweeper $rgb(hilight) 1 $1 $calc($2 + 47) $1 $2 $calc($1 + 77) $2
  drawline -nhr @mIRCSweeper $rgb(shadow) 1 $1 $calc($2 + 46) $calc($1 + 76) $calc($2 + 46) $calc($1 + 76) $2
  drawtext -pbnhr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $calc($1 + 18) $calc($2 + 3) Help
  
  drawline -nhr @mIRCSweeper $rgb(shadow) 1 $calc($1 + 3) $calc($2 + 22) $calc($1 + 73) $calc($2 + 22)
  drawline -nhr @mIRCSweeper $rgb(hilight) 1 $calc($1 + 3) $calc($2 + 23) $calc($1 + 73) $calc($2 + 23)
  
  drawtext -pbnhr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $calc($1 + 18) $calc($2 + 29) About
}

alias -l mIRCSweeper.HighlightHelpMenuItem {    
  if ($inrect(41,$1,41,22,75,18)) {
    mIRCSweeper.BuildHelpMenu 41 22
    drawrect -nhrf @mIRCSweeper $rgb(0,0,128) 1 $calc(41 + 2) $calc(22 + 2) 72 17
    drawtext -pbnhr @mIRCSweeper $rgb(255,255,255) $rgb(0,0,128) "MS Sans Serif" 12 $calc(41 + 18) $calc(22 + 3) Help
    drawdot @mIRCSweeper
  }
  elseif ($inrect(41,$1,41,51,75,18)) {
    mIRCSweeper.BuildHelpMenu 41 22
    drawrect -nhrf @mIRCSweeper $rgb(0,0,128) 1 $calc(41 + 2) $calc(22 + 28) 72 17
    drawtext -pbnhr @mIRCSweeper $rgb(255,255,255) $rgb(0,0,128) "MS Sans Serif" 12 $calc(41 + 18) $calc(22 + 29) About
    drawdot @mIRCSweeper
  }
  else { mIRCSweeper.BuildHelpMenu 41 22 }
}

menu @mIRCSweeper {
  mouse: {
    if ((%mIRCSweeper.GameMenuOpen == $false) && (%mIRCSweeper.HelpMenuOpen == $false)) {
      if ($inrect($mouse.x,$mouse.y,0,0,40,20)) {
        drawrect -nrf @mIRCSweeper $rgb(face) 1 0 0 102 22
        drawtext -pbnr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $int($calc((40 / 2) - ($width(Help,MS Sans Serif,12,0,1) / 2) + 37)) $int($calc(1 + (18 / 2) - ($height(Help,MS Sans Serif,12) / 2))) Help
        mIRCSweeper.DrawButton @mIRCSweeper 0 0 40 20 Game
        drawdot @mIRCSweeper 
      }
      elseif ($inrect($mouse.x,$mouse.y,39,0,34,20)) {
        drawrect -nrf @mIRCSweeper $rgb(face) 1 1 0 102 22
        drawtext -pbnr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $int($calc((40 / 2) - ($width(Game,MS Sans Serif,12,0,1) / 2))) $int($calc(1 + (18 / 2) - ($height(Game,MS Sans Serif,12) / 2))) Game
        mIRCSweeper.DrawButton @mIRCSweeper 40 0 34 20 Help 
        drawdot @mIRCSweeper
      }
      else {
        drawrect -nrf @mIRCSweeper $rgb(face) 1 0 0 102 22
        drawtext -pbnr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $int($calc((40 / 2) - ($width(Game,MS Sans Serif,12,0,1) / 2))) $int($calc(1 + (18 / 2) - ($height(Game,MS Sans Serif,12) / 2))) Game
        drawtext -pbnr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $int($calc((40 / 2) - ($width(Help,MS Sans Serif,12,0,1) / 2) + 37)) $int($calc(1 + (18 / 2) - ($height(Help,MS Sans Serif,12) / 2))) Help
        drawdot @mIRCSweeper
      }
    }
    else {
      if ($inrect($mouse.x,$mouse.y,0,0,40,20)) {
        if (%mIRCSweeper.GameMenuOpen == $false) { mIRCSweeper.ReDrawBoard }
        mIRCSweeper.DrawBox @mIRCSweeper 1 0 2 40 18 Game
        set %mIRCSweeper.GameMenuOpen $true
        set %mIRCSweeper.HelpMenuOpen $false
        mIRCSweeper.BuildGameMenu 1 22
        drawdot @mIRCSweeper 
      }
      elseif ($inrect($mouse.x,$mouse.y,39,0,34,20)) {
        if (%mIRCSweeper.HelpMenuOpen == $false) { mIRCSweeper.ReDrawBoard }
        mIRCSweeper.DrawBox @mIRCSweeper 1 40 2 34 18 Help 
        set %mIRCSweeper.GameMenuOpen $false
        set %mIRCSweeper.HelpMenuOpen $true
        mIRCSweeper.BuildHelpMenu 41 22
        drawdot @mIRCSweeper
      }
      if ($inrect($mouse.x,$mouse.y,1,22,124,135)) { if (%mIRCSweeper.GameMenuOpen == $true) { mIRCSweeper.HighlightMenuItem $mouse.y } }
      if ($inrect($mouse.x,$mouse.y,41,22,75,43)) { if (%mIRCSweeper.HelpMenuOpen == $true) { mIRCSweeper.HighlightHelpMenuItem $mouse.y } }
    }
    if (%mIRCSweeper.SquareClicked == $true) {
      if ($hget(PlayerMoves,$calc(%mIRCSweeper.ycoord + 1) $+ $chr(44) $+ $calc(%mIRCSweeper.xcoord + 1)) < 1) { mIRCSweeper.DrawSquare @mIRCSweeper $calc((%mIRCSweeper.xcoord * 16) + 13) $calc((%mIRCSweeper.ycoord * 16) + 76) 15 16 }
      if ($inrect($mouse.x,$mouse.y,13,77,$calc(%mIRCSweeper.width - 32),$calc(%mIRCSweeper.height - 111))) {
        set %mIRCSweeper.xcoord2 $int($calc(($mouse.x - 13) / 16))
        set %mIRCSweeper.ycoord2 $int($calc(($mouse.y - 77) / 16))
        if ($hget(PlayerMoves,$calc(%mIRCSweeper.ycoord2 + 1) $+ $chr(44) $+ $calc(%mIRCSweeper.xcoord2 + 1)) < 1) { mIRCSweeper.DrawSquareDown @mIRCSweeper $calc((%mIRCSweeper.xcoord2 * 16) + 13) $calc((%mIRCSweeper.ycoord2 * 16) + 76) 15 16 }
        set %mIRCSweeper.xcoord [ %mIRCSweeper.xcoord2 ]
        set %mIRCSweeper.ycoord [ %mIRCSweeper.ycoord2 ]
        drawdot @mIRCSweeper
      }
    }
  }
  sclick: {
    if ($inrect($mouse.x,$mouse.y,0,0,40,20)) {
      drawrect -nrf @mIRCSweeper $rgb(face) 1 0 0 102 22
      drawtext -pbnr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $int($calc((40 / 2) - ($width(Help,MS Sans Serif,12,0,1) / 2) + 37)) $int($calc(1 + (18 / 2) - ($height(Help,MS Sans Serif,12) / 2))) Help
      mIRCSweeper.DrawBox @mIRCSweeper 0 0 2 40 18 Game
      set %mIRCSweeper.GameMenuOpen $true
      set %mIRCSweeper.HelpMenuOpen $false
      mIRCSweeper.BuildGameMenu 1 22
      drawdot @mIRCSweeper 
    }
    elseif ($inrect($mouse.x,$mouse.y,40,0,34,20)) {
      drawrect -nrf @mIRCSweeper $rgb(face) 1 0 0 102 22
      drawtext -pbnr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $int($calc((40 / 2) - ($width(Game,MS Sans Serif,12,0,1) / 2))) $int($calc(1 + (18 / 2) - ($height(Game,MS Sans Serif,12) / 2))) Game
      mIRCSweeper.DrawBox @mIRCSweeper 0 40 2 34 18 Help 
      set %mIRCSweeper.GameMenuOpen $false
      set %mIRCSweeper.HelpMenuOpen $true
      mIRCSweeper.BuildHelpMenu 41 22
      drawdot @mIRCSweeper
    }
    else {
      if ((%mIRCSweeper.GameMenuOpen != $false) || (%mIRCSweeper.HelpMenuOpen != $false))  {
        if (!$inrect($mouse.x,$mouse.y,1,22,124,135)) {
          drawrect -nrf @mIRCSweeper $rgb(face) 1 1 0 102 22
          drawtext -pbnr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $int($calc((40 / 2) - ($width(Game,MS Sans Serif,12,0,1) / 2))) $int($calc(1 + (18 / 2) - ($height(Game,MS Sans Serif,12) / 2))) Game
          drawtext -pbnr @mIRCSweeper $rgb(0,0,0) $rgb(face) "MS Sans Serif" 12 $int($calc((40 / 2) - ($width(Help,MS Sans Serif,12,0,1) / 2) + 37)) $int($calc(1 + (18 / 2) - ($height(Help,MS Sans Serif,12) / 2))) Help
          set %mIRCSweeper.GameMenuOpen $false
          set %mIRCSweeper.HelpMenuOpen $false
          mIRCSweeper.ReDrawBoard
          drawdot @mIRCSweeper
        }
      }
    }
    if ($inrect($mouse.x,$mouse.y,13,77,$calc(%mIRCSweeper.width - 32),$calc(%mIRCSweeper.height - 111))) {
      if ($gettok(%mIRCSweeper.allowgameplay,1,32) != $false) {
        if ((%mIRCSweeper.GameMenuOpen == $false) && (%mIRCSweeper.HelpMenuOpen == $false)) {
          mIRCSweeper.DrawSmiley.2 @mIRCSweeper $calc((%mIRCSweeper.width - 6) / 2 - 9) 40 18 18
          if ($timer(UpdateGameTimer).secs == $null) { mIRCSweeper.GameTimer 1 }
          set %mIRCSweeper.xcoord $int($calc(($mouse.x - 13) / 16))
          set %mIRCSweeper.ycoord $int($calc(($mouse.y - 77) / 16))
          if ($hget(PlayerMoves,$calc(%mIRCSweeper.ycoord + 1) $+ $chr(44) $+ $calc(%mIRCSweeper.xcoord + 1)) < 1) { mIRCSweeper.DrawSquareDown @mIRCSweeper $calc((%mIRCSweeper.xcoord * 16) + 13) $calc((%mIRCSweeper.ycoord * 16) + 76) 15 16 }
          set %mIRCSweeper.SquareClicked $true
          drawdot @mIRCSweeper
        }
        elseif (!$inrect($mouse.x,$mouse.y,1,22,124,135)) {
          mIRCSweeper.DrawSmiley.2 @mIRCSweeper $calc((%mIRCSweeper.width - 6) / 2 - 9) 40 18 18
          if ($timer(UpdateGameTimer).secs == $null) { mIRCSweeper.GameTimer 1 }
          set %mIRCSweeper.xcoord $int($calc(($mouse.x - 13) / 16))
          set %mIRCSweeper.ycoord $int($calc(($mouse.y - 77) / 16))
          if ($hget(PlayerMoves,$calc(%mIRCSweeper.ycoord + 1) $+ $chr(44) $+ $calc(%mIRCSweeper.xcoord + 1)) < 1) { mIRCSweeper.DrawSquareDown @mIRCSweeper $calc((%mIRCSweeper.xcoord * 16) + 13) $calc((%mIRCSweeper.ycoord * 16) + 76) 15 16 }
          set %mIRCSweeper.SquareClicked $true
          drawdot @mIRCSweeper
        }
      }
    }
    elseif ($inrect($mouse.x,$mouse.y,$calc((%mIRCSweeper.width - 6) / 2 - 12),37,24,24)) {
      if ((%mIRCSweeper.GameMenuOpen == $false) && (%mIRCSweeper.HelpMenuOpen == $false)) {
        mIRCSweeper.DrawButtonDown @mIRCSweeper $calc((%mIRCSweeper.width - 6) / 2 - 12) 37 24 24
        mIRCSweeper.DrawSmiley.1 @mIRCSweeper $calc((%mIRCSweeper.width - 6) / 2 - 9) 40 18 18
        drawdot @mIRCSweeper
      }
      elseif (!$inrect($mouse.x,$mouse.y,1,22,124,135)) {
        mIRCSweeper.DrawButtonDown @mIRCSweeper $calc((%mIRCSweeper.width - 6) / 2 - 12) 37 24 24
        mIRCSweeper.DrawSmiley.1 @mIRCSweeper $calc((%mIRCSweeper.width - 6) / 2 - 9) 40 18 18
        drawdot @mIRCSweeper
      }
    }    
  }
  uclick: {
    if ((%mIRCSweeper.GameMenuOpen != $true) && (%mIRCSweeper.HelpMenuOpen != $true)) {
      if (!$inrect($mouse.x,$mouse.y,$calc((%mIRCSweeper.xcoord * 16) + 13),$calc((%mIRCSweeper.ycoord * 16) + 76),15,16)) {
        if ($hget(PlayerMoves,$calc(%mIRCSweeper.ycoord + 1) $+ $chr(44) $+ $calc(%mIRCSweeper.xcoord + 1)) < 1) { mIRCSweeper.DrawSquare @mIRCSweeper $calc((%mIRCSweeper.xcoord * 16) + 13) $calc((%mIRCSweeper.ycoord * 16) + 76) 15 16 }
        set %mIRCSweeper.SquareClicked $false
        unset %mIRCSweeper.xcoord %mIRCSweeper.ycoord
        drawdot @mIRCSweeper
      }
      else {
        if ($hget(PlayerMoves,$calc(%mIRCSweeper.ycoord + 1) $+ $chr(44) $+ $calc(%mIRCSweeper.xcoord + 1)) < 1) { 
          hadd PlayerMoves $calc(%mIRCSweeper.ycoord + 1) $+ $chr(44) $+ $calc(%mIRCSweeper.xcoord + 1) 1
          mIRCSweeper.DrawSquareDown @mIRCSweeper $calc((%mIRCSweeper.xcoord * 16) + 13) $calc((%mIRCSweeper.ycoord * 16) + 76) 15 16 $hget(GameBoard,$calc(%mIRCSweeper.ycoord + 1) $+ $chr(44) $+ $calc(%mIRCSweeper.xcoord + 1)) 
        }
        set %mIRCSweeper.SquareClicked $false
        unset %mIRCSweeper.xcoord %mIRCSweeper.ycoord
      }
      if ($inrect($mouse.x,$mouse.y,$calc((%mIRCSweeper.width - 6) / 2 - 12),37,24,24)) {
        mIRCSweeper.DrawButton @mIRCSweeper $calc((%mIRCSweeper.width - 6) / 2 - 12) 37 24 24
        mIRCSweeper.DrawSmiley.1 @mIRCSweeper $calc((%mIRCSweeper.width - 6) / 2 - 9) 40 18 18
        .timerUpdateGameTimer off
        mIRCSweeper.2 $readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Settings,LastLevel)
      }
      else {
        mIRCSweeper.DrawButton @mIRCSweeper $calc((%mIRCSweeper.width - 6) / 2 - 12) 37 24 24
        if ($gettok(%mIRCSweeper.allowgameplay,1,32) != $false) { mIRCSweeper.DrawSmiley.1 @mIRCSweeper $calc((%mIRCSweeper.width - 6) / 2 - 9) 40 18 18 }
        else { 
          if ($gettok(%mIRCSweeper.allowgameplay,2,32) == Lose) { mIRCSweeper.DrawSmiley.3 @mIRCSweeper $calc((%mIRCSweeper.width - 6) / 2 - 9) 40 18 18 }
          else { mIRCSweeper.DrawSmiley.4 @mIRCSweeper $calc((%mIRCSweeper.width - 6) / 2 - 9) 40 18 18 }
        }
        drawdot @mIRCSweeper
      }
    }
    elseif (%mIRCSweeper.GameMenuOpen == $true) {
      if ($inrect($mouse.x,$mouse.y,1,22,124,18)) { .timerUpdateGameTimer off | set %mIRCSweeper.GameMenuOpen $false | mIRCSweeper $readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Settings,LastLevel) } 
      elseif ($inrect($mouse.x,$mouse.y,1,51,124,18)) { .timerUpdateGameTimer off | set %mIRCSweeper.GameMenuOpen $false | mIRCSweeper Beginner } 
      elseif ($inrect($mouse.x,$mouse.y,1,69,124,18)) { .timerUpdateGameTimer off | set %mIRCSweeper.GameMenuOpen $false | mIRCSweeper Intermediate } 
      elseif ($inrect($mouse.x,$mouse.y,1,87,124,18)) { .timerUpdateGameTimer off | set %mIRCSweeper.GameMenuOpen $false | mIRCSweeper Expert } 
      elseif ($inrect($mouse.x,$mouse.y,1,113,124,18)) { dialog -ma mIRCSweeper.HighScores mIRCSweeper.HighScores | mIRCSweeper.ReDrawBoard } 
      elseif ($inrect($mouse.x,$mouse.y,1,139,124,18)) { .timerUpdateGameTimer off | window -c @mIRCSweeper | unset %mIRCSweeper.* } 
    }
    elseif (%mIRCSweeper.HelpMenuOpen == $true) {
      if ($inrect($mouse.x,$mouse.y,41,22,75,18)) { run notepad " $+ $scriptdirreadme-msweep.txt $+ " }
      elseif ($inrect($mouse.x,$mouse.y,41,51,75,18)) { dialog -ma mIRCSweeper.About mIRCSweeper.About }
    }
  }
  rclick: {
    if ($inrect($mouse.x,$mouse.y,13,77,$calc(%mIRCSweeper.width - 32),$calc(%mIRCSweeper.height - 111))) {
      if ($gettok(%mIRCSweeper.allowgameplay,1,32) != $false) {
        var %mIRCSweeper.rclickxcoord = $int($calc(($mouse.x - 13) / 16))
        var %mIRCSweeper.rclickycoord = $int($calc(($mouse.y - 76) / 16))
        if ($hget(PlayerMoves,$calc(%mIRCSweeper.rclickycoord + 1) $+ $chr(44) $+ $calc(%mIRCSweeper.rclickxcoord + 1)) == 0) {
          dec %mIRCSweeper.minesleft
          mIRCSweeper.DrawFlag @mIRCSweeper $calc((%mIRCSweeper.rclickxcoord * 16) + 13) $calc((%mIRCSweeper.rclickycoord * 16) + 76) 15 16
          hadd PlayerMoves $calc(%mIRCSweeper.rclickycoord + 1) $+ $chr(44) $+ $calc(%mIRCSweeper.rclickxcoord + 1) 2
          mIRCSweeper.Numbers 18 38 %mIRCSweeper.minesleft
          drawdot @mIRCSweeper
        }
        elseif ($hget(PlayerMoves,$calc(%mIRCSweeper.rclickycoord + 1) $+ $chr(44) $+ $calc(%mIRCSweeper.rclickxcoord + 1)) == 2) {
          inc %mIRCSweeper.minesleft
          mIRCSweeper.DrawSquare @mIRCSweeper $calc((%mIRCSweeper.rclickxcoord * 16) + 13) $calc((%mIRCSweeper.rclickycoord * 16) + 76) 15 16
          hadd PlayerMoves $calc(%mIRCSweeper.rclickycoord + 1) $+ $chr(44) $+ $calc(%mIRCSweeper.rclickxcoord + 1) 0
          mIRCSweeper.Numbers 18 38 %mIRCSweeper.minesleft
          drawdot @mIRCSweeper
        }
      }
    }
  }
}

on *:keyup:@mIRCSweeper:113: { 
  if ($hget(GameBoard,0).item == 64) { .timerUpdateGameTimer off | mIRCSweeper.2 Beginner }
  elseif ($hget(GameBoard,0).item == 256) { .timerUpdateGameTimer off | mIRCSweeper.2 Intermediate }
  else { .timerUpdateGameTimer off | mIRCSweeper.2 Expert }
}
  

on 1:close:@: { 
  if ($target == @mIRCSweeper) { 
    unset %mIRCSweeper.*
    .timerUpdateGameTimer off
    hfree GameBoard
    hfree PlayerMoves 
  }   
}

dialog -l mIRCSweeper.HighScores {
  title "Best Times"
  size -1 -1 325 155
  box "Fastest mIRC Sweepers", 3, 10 11 305 102
  
  text "Beginner:", 4, 20 34 75 16
  text "", 5, 115 34 75 16
  text "", 6, 212 34 75 16
  
  text "Intermediate:", 7, 20 59 75 16
  text "", 8, 115 59 75 16
  text "", 9, 212 59 75 16
  
  text "Expert:", 10, 20 84 75 16
  text "", 11, 115 84 75 16
  text "", 12, 212 84 75 16
  
  button "Reset Scores", 2, 140 122 85 23, default
  button "Ok", 1, 230 122 85 23, ok
}

on 1:dialog:mIRCSweeper.HighScores:init:0: {
  did -a mIRCSweeper.HighScores 5 $readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Beginner,Time) seconds
  did -a mIRCSweeper.HighScores 6 $readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Beginner,Name)
  did -a mIRCSweeper.HighScores 8 $readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Intermediate,Time) seconds
  did -a mIRCSweeper.HighScores 9 $readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Intermediate,Name)
  did -a mIRCSweeper.HighScores 11 $readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Expert,Time) seconds
  did -a mIRCSweeper.HighScores 12 $readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Expert,Name)
}

on 1:dialog:mIRCSweeper.HighScores:sclick:2: { 
  writeini -n " $+ $scriptdirmIRCSweeper.ini $+ " Beginner Name Anonymous
  writeini -n " $+ $scriptdirmIRCSweeper.ini $+ " Beginner Time 999
  writeini -n " $+ $scriptdirmIRCSweeper.ini $+ " Intermediate Name Anonymous
  writeini -n " $+ $scriptdirmIRCSweeper.ini $+ " Intermediate Time 999
  writeini -n " $+ $scriptdirmIRCSweeper.ini $+ " Expert Name Anonymous
  writeini -n " $+ $scriptdirmIRCSweeper.ini $+ " Expert Time 999
  
  did -a mIRCSweeper.HighScores 5 $readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Beginner,Time) seconds
  did -a mIRCSweeper.HighScores 6 $readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Beginner,Name)
  did -a mIRCSweeper.HighScores 8 $readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Intermediate,Time) seconds
  did -a mIRCSweeper.HighScores 9 $readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Intermediate,Name)
  did -a mIRCSweeper.HighScores 11 $readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Expert,Time) seconds
  did -a mIRCSweeper.HighScores 12 $readini(" $+ $scriptdirmIRCSweeper.ini $+ ",Expert,Name) 
}

dialog mIRCSweeper.About {
  title "About mIRCSweeper"
  size -1 -1 185 95
  
  text "mIRCSweeper v1.0", 2, 10 10 100 16
  text "mIRC 5.91+", 3, 10 26 75 16  
  text "by Smay -", 4, 10 42 50 16
  link "smayscripts@gmail.com", 5, 60 42 115 16
  button "Ok", 1, 55 63 70 23, ok
}